﻿using System.ComponentModel.DataAnnotations;

namespace Connected.Security.Authentication
{
	/// <summary>
	/// Represents the token based authentication. This is usually used by
	/// devices and processes which does not have a direct identity. The identity
	/// is then resolved via mapping between the provided token and a user.
	/// </summary>
	public sealed class BearerAuthenticationArgs : AuthenticationArgs
	{
		/// <summary>
		/// The bearer token.
		/// </summary>
		[Required]
		[MaxLength(128)]
		public string Token { get; init; }
	}
}
